#!/bin/bash
#path to ppp
ppp=/etc/ppp

if [[ $(id) != 'uid=0'* ]]; then
echo "Only root can set up VPN connections. Also you can use 'sudo'."
exit 1
fi
echo "Welcome to VPN connection setup wizard! You'll be asked a few questions, and if you answer right - you'll get a working VPN connection with correct routing. Remember that 99% mistakes during VPN connection setup using this script is banal inattention. Be attentive and have luck!"
echo "So, let's begin!"
echo "------------------------"
printf "Enter your VPN connection name (e.g. corbina or vpn_corbina): "
read i_vpn_name
echo "------------------------"
echo "Please choose your provider:"
echo "   1. Corbina Telecom"
echo "   2. Beeline"
echo "   3. Other"
printf "Your provider is ...? (1/2/3)? " 
read provider
if [ $provider = "1" ]; then
prov="Corbina Telecom"
vpn_address="vpn.corbina.net"
elif [ $provider = "2" ]; then
prov="Beeline"
vpn_address="vpn.internet.beeline.ru"
elif [ $provider = "3" ]; then
prov="Other"
echo "WARNING! You have to edit 'route' file attached to this script manually as it's configured to work with Corbina and Beeline only. Check your routing settings at your provider's technical support. Stop this script with Ctrl+C, edit 'route' file and then restart script."
echo "------------------------"
printf "Enter your VPN address: "
read vpn_address
else
echo "You've entered wrong answer. Please restart this script."
exit 1
fi

if [ $provider = "3" ]; then
region="3"
routes="route"
else
echo "------------------------"
echo "Please choose your region:"
echo "   1. Moscow region"
echo "   2. St.Petersburg region"
echo "   3. other"
printf "Your region is ...? (1/2/3)? "
read region
if [ $region = "1" ]; then
region_name="Moscow region"
routes="route.msk"
elif [ $region = "2" ]; then
region_name="St.Petersburg region"
routes="route.piter"
elif [ $region = "3" ]; then
region_name="other"
routes="route"
else
echo "You've entered wrong answer. Please restart this script."
exit 1
fi
fi

echo "------------------------"
printf "Enter your internet login: "
read i_login
echo "------------------------"
printf "Enter your internet password: "
read i_password

echo "------------------------"
echo "Trying to detect your gateway IP automatically..." 
i_gw=$(route|grep default|awk '{print $2}')
echo "Detected!"
echo "Your local gateway IP is $i_gw"
if [ $provider = "3" ]; then
printf "Is this correct? (y/n)"
read i_yn
if [ $i_yn = "n" ]; then
printf "Enter your gateway IP: "
read i_gw
fi
else
if [[ $i_gw != '10.'* ]]; then
echo "Unfortunately, the gateway IP wasn't detected correctly. It must look like 10.x.x.x, so you have to enter it manually."
printf "Enter your gateway IP: "
read i_gw
fi
fi
if [ $region = "2" ]; then
routing="Pre-set routes are in 'route' file as St.Petersburg and it's region doesn't have DHCP-routing support."
i_dhcp="n"
else
echo "------------------------"
echo "Now you have to choose routing setup method. You can choose DHCP routing or pre-set routes in 'route' file."
echo "------------------------"
printf "Do you want to get routes via DHCP? ([y]/n)? " 
read i_dhcp
if [ $i_dhcp = "y" ]; then
routing="via DHCP"
elif [ $i_dhcp = "n" ]; then
routing="pre-set in 'route' file"
if [ $provider = "3" ]; then
echo "WARNING! You have to edit 'route' file attached to this script manually as it's configured to work with Corbina and Beeline only. Check your routing settings at your provider's technical support. Stop this script with Ctrl+C, edit 'route' file and then restart script."
fi
else
echo "You've entered wrong answer. Please restart this script."
exit 1
fi
fi
echo "------------------------"
printf "Do you want to automatically install pptp-linux package? Answer 'n' if it's already installed or you have old distro (Debian Etch, Xandros on Eee PC etc.) (y/n): " 
read i_install
if [ $i_install = "y" ]; then
pptp_linux="Yes"
else
pptp_linux="No"
fi
echo "------------------------"
echo "Checking gathered information :"
echo "		Connection name: $i_vpn_name"
echo "		Provider: $prov"
if [[ $provider != "3" ]]; then
echo "		Region: $region_name"
fi
echo "		Login: $i_login"
echo "		Password: $i_password"
echo "		VPN address: $vpn_address"
echo "		Gateway: $i_gw"
echo "		Routing setup: $routing"
echo "		pptp-linux package setup: $pptp_linux"
printf "Is this correct? (y/n)? "
read i_correct
if [ $i_correct = "n" ]; then
echo "------------------------"
echo "Check the information and restart this script."
exit 1
fi

if [ $i_install = "y" ]; then
echo "Detecting your system type..."
bit=$(uname -m)
echo "Your system is detected as: $bit"
echo "Installing $bit version of pptp-linux..."
if [ $bit = "i686" ]; then
dpkg -i "$PWD"/pptp-linux_1.7.0-2ubuntu2_i386.deb
elif [ $bit = "x86_64" ]; then
dpkg -i "$PWD"/pptp-linux_1.7.0-2ubuntu2_amd64.deb
fi
fi

if [ $i_dhcp = "y" ]; then
cp "$PWD"/rfc3442-classless-static-routes /etc/dhcp3/dhclient-exit-hooks.d/rfc3442-classless-static-routes
mv /etc/dhcp3/dhclient.conf /etc/dhcp3/dhclient.conf_bak
cp "$PWD"/dhclient.conf /etc/dhcp3/dhclient.conf
echo "------------------------"
echo "Routing auto-setup via DHCP installed."
fi
echo "------------------------"
echo "Writing parameters for VPN connection..."


echo "${i_login} PPTP ${i_password} *" > $ppp/chap-secrets


cp "$PWD"/ip $ppp/ip-up > /dev/null
printf "${ppp}/ip-up.d/\$6 \$1 \$2 \$3 \$4 \$5 \$6" >> $ppp/ip-up
chmod a+x $ppp/ip-up

cp "$PWD"/ip $ppp/ip-down > /dev/null
printf "${ppp}/ip-down.d/\$6 \$1 \$2 \$3 \$4 \$5 \$6" >> $ppp/ip-down
chmod a+x $ppp/ip-down

cp "$PWD"/$routes $ppp/ip-up.d/$i_vpn_name

printf "route del \$4 dev \$1\n" >> $ppp/ip-up.d/$i_vpn_name
printf "route add -host \$4 gw ${i_gw}\n" >> $ppp/ip-up.d/$i_vpn_name
printf "do_route add ${i_gw} \n" 	>> $ppp/ip-up.d/$i_vpn_name
printf "route del default \n" 	  	>> $ppp/ip-up.d/$i_vpn_name
printf "route add default dev \$1 \n" 	>> $ppp/ip-up.d/$i_vpn_name

chmod a+x $ppp/ip-up.d/$i_vpn_name

cp "$PWD"/$routes $ppp/ip-down.d/$i_vpn_name
printf "do_route del ${i_gw} \n"	>> $ppp/ip-down.d/$i_vpn_name
printf "route del default \n" 		>> $ppp/ip-down.d/$i_vpn_name
printf "route add default gw ${i_gw}\n" >> $ppp/ip-down.d/$i_vpn_name
chmod a+x $ppp/ip-down.d/$i_vpn_name

printf "nodeflate\nnobsdcomp\nnoauth\n" > $ppp/options.$i_vpn_name

printf "pty \"pptp $vpn_address --nolaunchpppd --nobuffer --loglevel 0\"\n" > $ppp/peers/$i_vpn_name
printf "connect /bin/true\n" >> $ppp/peers/$i_vpn_name
printf "name ${i_login}\n" >> $ppp/peers/$i_vpn_name
printf "remotename PPTP\n" >> $ppp/peers/$i_vpn_name
printf "file ${ppp}/options.$i_vpn_name\n" >> $ppp/peers/$i_vpn_name
printf "ipparam $i_vpn_name\n" >> $ppp/peers/$i_vpn_name
printf "persist\n" >> $ppp/peers/$i_vpn_name
printf "maxfail 0\n" >> $ppp/peers/$i_vpn_name
printf "lcp-echo-interval 30\n" >> $ppp/peers/$i_vpn_name
printf "lcp-echo-failure 4\n" >> $ppp/peers/$i_vpn_name
printf "mtu 1460\n" >> $ppp/peers/$i_vpn_name
echo "------------------------"
echo "Settings optimization is done!"
echo "------------------------"
echo "Auto reconnect is set up!"
echo "------------------------"
echo "Parameters setup succeeded!"
echo "------------------------"
echo "Restartint network services..."
/etc/init.d/networking restart
echo "Done!"
echo "------------------------"
printf "Do you want to establish your VPN connection now? ([y]/n)? " 
read i_vpnstart
if [ $i_vpnstart = "y" ]; then
echo "------------------------"
echo "Starting VPN connection..."
pon $i_vpn_name
echo "VPN connection is set up and running. If it's all OK and you pay your internet bills then you're already using Internet :)"
echo "------------------------"
echo "To connect, type: sudo pon $i_vpn_name" 
echo "To disconnect: sudo poff"
echo "------------------------"
echo "Don't forget to thank us at forum) All questions about this script - http://homenet.corbina.net/index.php?showtopic=199266"
else
echo "------------------------"
echo "To connect, type: sudo pon $i_vpn_name" 
echo "To disconnect: sudo poff"
echo "------------------------"
echo " Don't forget to thank us at forum) All questions about this script - http://homenet.corbina.net/index.php?showtopic=199266"
fi
exit 0
